<?
use Bitrix\Main;
use Bitrix\Main\Application;
use Bitrix\Main\Localization\Loc;
use Bitrix\Main\Config\Option;
use Bitrix\Sale;

Loc::loadMessages(__FILE__); 

Class CScoderToolsEvents
{
	const PASSWORD_LENGTH = 4;
	const IMSHOP_TIMEOUT = 120;
	public static function OnBeforePrologHandler()
    {
		
	}
	function OnBeforeConstructorActionHandler(&$params)
	{
		$btrue = true;
		$jsonPost = json_decode(file_get_contents('php://input'), true);
		
		switch ($params["profile"]["UF_API_MODE"]) {		//Метод АПИ
			case "users.otp":								//imshop.io: авторизация по номеру телефона + SMS [users.otp]
				if (isset($jsonPost["userIdentifier"]) && $jsonPost["userIdentifier"] != "")
				{
					$params["filter"]["PERSONAL_PHONE"] = $jsonPost["userIdentifier"];
				}
				else
				{
					$btrue = false;
				}
				break;
			case "users.user":								//imshop.io: получение данных учётной записи [users.user]
			case "users.user.update":						//imshop.io: редактирование данных учётной записи [users.user.update]
			
				if (isset($jsonPost["userIdentifier"]) && $jsonPost["userIdentifier"] != "")
				{
					//$params["filter"]["PERSONAL_PHONE"] = $jsonPost["userIdentifier"];
					$params["filter"]["ID"] = $jsonPost["userIdentifier"];		//КАК ОКАЗАЛОСЬ ПРИ ПОЛУЧЕНИИ ПРОФИЛЯ ПРИХОДИТ УЖЕ ИД ПОЛЬЗОВАТЕЛЯ, А НЕ ТЕЛЕФОНБ КАК ПРИ РЕГИСТРАЦИИ
				}
				else
				{
					$btrue = false;
				}
				//file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-log.txt', date("d.m.Y H:i:s -- ") . '$jsonPost: ' . var_export($jsonPost, true) . "\n", FILE_APPEND);		
				break;
		}
		return $btrue;
	}
	function OnBeforeConstructorResultShowHandler(&$result, $params)
	{
		global $DB;
		if (isset($result["gender"]) && $result["gender"] != "")
			$result["gender"] = ToLower($result["gender"]);
		
		$jsonPost = json_decode(file_get_contents('php://input'), true);
		switch ($params["profile"]["UF_API_MODE"]) {		//Метод АПИ
			case "users.otp":								//imshop.io: авторизация по номеру телефона + SMS [users.otp]
				if ((isset($jsonPost["userIdentifier"]) && $jsonPost["userIdentifier"] != "")
					&& $result["id"] > 0)
				{
					if (!isset($jsonPost["otp"]) || $jsonPost["otp"] == "")		//если код пустой
					{
						//ОТПРАВИТЬ КОД НА НОМЕР ТЕЛЕФОНА
						$bsend = self::__send_sms($result);
					}
					else
					{
						$filter = Array(
							"ID" => $result["id"],
						);
						$rsUsers = CUser::GetList(($by="id"), ($order="desc"), $filter, array("NAV_PARAMS" => array("nTopCount" => 1), "FIELDS" => array("ID"),"SELECT" => array("UF_IMSHIOP_CODE","UF_IMSHIOP_TIME")));
						if ($user = $rsUsers->Fetch())
						{
							//если КОД верный
							if ($jsonPost["otp"] == $user["UF_IMSHIOP_CODE"])
							{
								$diff = time() - $user["UF_IMSHIOP_TIME"];
								
								$imshop_timeout = (int) Option::get("scoder.tools", "IMSHOP_TIMEOUT");
								if ($imshop_timeout <= 0)
									$imshop_timeout = self::IMSHOP_TIMEOUT;
								
								if ($diff <= $imshop_timeout)
								{
									$res = $result;
									$result = array("user" => $res);		//модернизируем ответ, чтоб был согласно требованиям imshop.io	https://docs.imshop.io/api/extra-integrations/users/otp
								}
								else
								{
									$result = array(
										"error" => array(
											"message" => GetMessage("SCODER_TOOLS_IMSHOPIO_ERROR_TIMOUT")
										)
									);
								}
							}
							else
							{
								$result = array(
									"error" => array(
										"message" => GetMessage("SCODER_TOOLS_IMSHOPIO_ERROR_MESSAGE")
									)
								);
							}
						}
						else
						{
							$result = array(
								"error" => array(
									"message" => GetMessage("SCODER_TOOLS_IMSHOPIO_ERROR_NOTFOUND")
								)
							);
						}
					}
				}
				elseif ((isset($jsonPost["userIdentifier"]) && $jsonPost["userIdentifier"] != "")
					&& $result["id"] <= 0
						&& (!isset($jsonPost["otp"]) || $jsonPost["otp"] == "")
					)
				{
					//ЕСЛИ ПОЛЬЗОВАТЕЛЬ НЕ НАЙДЕН
					if (!isset($jsonPost["email"]))
					{
						//запросить дополнительные данные для регистраци
						$result = array(
							"dataRequired" => array("email", "fullName", "birthday", "gender")
						);
					}
					else
					{
						$password = randString(7, array("0123456789","abcdefghijklnmopqrstuvwxyz","ABCDEFGHIJKLNMOPQRSTUVWXYZ"));
						//создать пользователя
						$user = new CUser;
						$load = Array(
							"EMAIL"             => $jsonPost["email"],
							"LOGIN"             => $jsonPost["email"],
							"LID"               => "ru",
							"ACTIVE"            => "Y",
							"GROUP_ID"          => array(3,4),
							"PASSWORD"          => $password,
							"CONFIRM_PASSWORD"  => $password,
							"PERSONAL_PHONE"    => $jsonPost["userIdentifier"],
						);
						if (isset($jsonPost["fullName"]))
							$load["NAME"] = $jsonPost["fullName"];
						
						if (isset($jsonPost["gender"]))
							$load["PERSONAL_GENDER"] = ToUpper($jsonPost["gender"]);
						
						if (isset($jsonPost["birthday"]))
						{
							$birthday = "";
							if ($jsonPost["birthday"] != "")
							{
								$birthday = $DB->FormatDate($jsonPost["birthday"], "YYYY-MM-DD", "DD.MM.YYYY");
							}
							$load["PERSONAL_BIRTHDAY"] = $birthday;
						}
						
						if ($id = $user->Add($load))
						{
							//ОТПРАВИТЬ КОД НА НОМЕР ТЕЛЕФОНА
							$result = array(
								"id" => $id,
								"phone" => $jsonPost["userIdentifier"],
							);
							
							$bsend = self::__send_sms($result);
						}
						else
						{
							$result = array(
								"error" => array(
									"message" => $user->LAST_ERROR,	//GetMessage("SCODER_TOOLS_IMSHOPIO_ERROR_GENERAL")
								)
							);
						}
					}
				}
				else
				{
					$result = array(
						"error" => array(
							"message" => GetMessage("SCODER_TOOLS_IMSHOPIO_ERROR_GENERAL")
						)
					);
				}
				if (isset($bsend) && $bsend === false)
				{
					$result = array(
						"error" => array(
							"message" => GetMessage("SCODER_TOOLS_IMSHOPIO_ERROR_SEND")
						)
					);
				}
				break;
			case "users.user":							//imshop.io: получение и редактирование данных учётной записи [users.user]
				if ((isset($jsonPost["userIdentifier"]) && $jsonPost["userIdentifier"] != "")
					&& $result["id"] > 0)
				{
					$res = $result;
					$result = array("user" => $res);			//модернизируем ответ, чтоб был согласно требованиям imshop.io	https://docs.imshop.io/api/extra-integrations/users/user
				}
				else
				{
					$result = array(
						"error" => array(
							"message" => GetMessage("SCODER_TOOLS_IMSHOPIO_ERROR_NOTFOUND")
						)
					);
				}
				if (isset($result["gender"]) && $result["gender"] != "")
					$result["gender"] = ($result["gender"] == "f" ? "female" : "male");
				if (isset($result["birthday"]) && $result["birthday"] != "")
					$result["birthday"] = $DB->FormatDate($result["birthday"], "DD.MM.YYYY", "YYYY-MM-DD");
				break;
			case "users.user.update";
				if ((isset($jsonPost["userIdentifier"]) && $jsonPost["userIdentifier"] != "")
					&& $result["id"] > 0)
				{
					$phone = $jsonPost["userIdentifier"];
					
					$user = new CUser;
					$load = Array(
						"PERSONAL_PHONE"    => $phone,
					);
					if (isset($jsonPost["email"]))
						$load["EMAIL"] = $result["email"] = $jsonPost["email"];
					if (isset($jsonPost["name"]))
						$load["NAME"] = $result["name"] = $jsonPost["name"];
					if (isset($jsonPost["phone"]))
						$load["PERSONAL_PHONE"] = $result["phone"] = $jsonPost["phone"];
					if (isset($jsonPost["gender"]))
					{
						$result["gender"] = $jsonPost["gender"];
						$load["PERSONAL_GENDER"] = ToUpper($jsonPost["gender"]);
					}
					
					if (isset($jsonPost["birthday"]))
					{
						$birthday = "";
						if ($jsonPost["birthday"] != "")
						{
							$birthday = $DB->FormatDate($jsonPost["birthday"], "YYYY-MM-DD", "DD.MM.YYYY");
						}
						$load["PERSONAL_BIRTHDAY"] = $birthday;
					}
					if ($id = $user->Update($result["id"],$load))
					{
						$res = $result;
						$result = array("user" => $res);		//модернизируем ответ, чтоб был согласно требованиям imshop.io	https://docs.imshop.io/api/extra-integrations/users/user
					}
					else
					{
						$result = array(
							"error" => array(
								"message" => $user->LAST_ERROR,		//GetMessage("SCODER_TOOLS_IMSHOPIO_ERROR_NOTUPDATE")
							)
						);
					}
				}
				break;
		}
		
		return true;
	}
	function __send_sms(&$result)
	{
		$return = false;
		if (\Bitrix\Main\Loader::includeModule('bxmaker.authuserphone'))
		{
			//ОТПРАВИТЬ КОД НА НОМЕР ТЕЛЕФОНА
			if (isset($result["phone"]) && $result["phone"] !="")
				$phone = $result["phone"];
			elseif (isset($result["userIdentifier"]) && $result["userIdentifier"] !="")
				$phone = $result["userIdentifier"];
				
			$siteId =  CScoderTools::__get_site();
			
			$oManager = \BXmaker\AuthUserPhone\Manager::getInstance();
			$oManager->setSiteId($siteId);
			$res = $oManager->service()->startSmsCode($phone);
			
			if (!$res->isSuccess()) 
			{
				$error = $res->throwException();
			}
			else
			{
				// $answer = [           
					// 'TIMEOUT' => $res->getMore('TIMEOUT'),
					// 'LENGTH' => $res->getMore('LENGTH'),
					// 'MSG' => $res->getMore('MSG'),
				// ];
				
				$dbrHistory = \BXmaker\AuthUserPhone\Manager::getInstance()->service()->history()->table()->getList([
					'order' => [
						'ID' => 'DESC'
					],
					'filter' => [
						'SITE_ID' => $siteId,
						'PHONE' => $phone,
						'ACTION' => \BXmaker\AuthUserPhone\Manager::getInstance()->service()->getAction(),
						'CONFIRM_TYPE' => \BXmaker\AuthUserPhone\Manager::CONFIRM_TYPE_SMS_CODE
					],
					'limit' => 1,
				]);
				if ($arHistoryItem = $dbrHistory->fetch()) 
				{
					$otp = $arHistoryItem["PARAMS"]["CODE"];
					
					$user = new CUser;
					$load = Array(
						"UF_IMSHIOP_CODE" => $otp,		//imshop.io: временный код подтверждения по SMS
						"UF_IMSHIOP_TIME" => time(),	//imshop.io: дата генерации временного кода (unix)
					);
					
					if ($result["id"] > 0)
					{
						if ($id = $user->Update($result["id"],$load))
						{
							$phone_format = substr_replace($phone,'****',4,5);
							$otp_length = (int) Option::get("scoder.tools", "OTP_LENGTH");				//Длина OTP для imshop.io (по умолчанию 4
							if ($otp_length <= 0)
								$otp_length = self::PASSWORD_LENGTH;
							
							$imshop_timeout = (int) Option::get("scoder.tools", "IMSHOP_TIMEOUT");		//Сколько секунд осталось до возможности повторно запросить OTP (по умолчанию 120 секунд)
							if ($imshop_timeout <= 0)
								$imshop_timeout = self::IMSHOP_TIMEOUT;
							
							$result = array(
								"otp" => array(
									"timeout" => $imshop_timeout,		//сколько секунд осталось до возможности повторно запросить OTP (необязательное поле; по умолчанию 120 секунд)
									//"attemptsLeft" => 10,				//сколько ещё одноразовых паролей можно запросить (необязательное поле; по умолчанию количество неограниченное)
									"message" => GetMessage("SCODER_TOOLS_IMSHOPIO_MESSAGE", array("#PHONE#" => $phone_format)),	//сообщение для пользователя (обязательное поле)
									"codeLength" => $otp_length			//длина OTP (необязательное поле; по умолчанию 4)
								)
							);
							$return = true;
						}
					}
				}
			}
		}
		
		return $return;
	}
	function OnSaleOrderBeforeSavedHandler(\Bitrix\Main\Event $event)
	{
		if (is_null($GLOBALS["SCODER_TOOLS"]))
		{
			
		}
	}
	function OnSaleOrderSavedHandler(\Bitrix\Main\Event $event)
	{
		if (is_null($GLOBALS["SCODER_TOOLS"]))
		{
			
		}
	}
	function OnSaleOrderCanceledHandler(\Bitrix\Main\Event $event)
	{
		if (is_null($GLOBALS["SCODER_TOOLS"]))
		{
			
		}
	}
	function OnSaleStatusOrderChangeHandler(\Bitrix\Main\Event $event)
	{
		if (is_null($GLOBALS["SCODER_TOOLS"]) && Option::get("scoder.tools", "ACTIVE_SET_STATUS") == "Y")
		{
			$order   = $event->getParameter("ENTITY");
			
			$ar = array(
				"id" => $order->getId(),					//Номер заказа в системе клиента 
				"code" => $order->getField('STATUS_ID'),	//Идентификатор статуса заказа в системе клиента
				//"message" => "",							//опционально, статус заказа в текстовом виде. Этот текст увидит покупатель в приложении
				//"trackingUrl" => "",						//опционально, ссылка на страницу отслеживания почтового или курьерского отправления
				//"userId" => ""							//опционально, идентификатор покупателя в вашей системе. В его качестве также может выступать номер телефона без форматирования. Используется для отправки пуш-уведомлений о заказах, сделанных не через приложение
			);
			
			$queryUrl = Option::get("scoder.tools", "ORDER_STATUS_URL");		//URL страницы для отправки изменений статусов по заказу
			
			$result = self::__curl_query($queryUrl, $ar);
			//file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-log.txt', date("d.m.Y H:i:s -- ") . '$result: ' . var_export($result, true) . "\n", FILE_APPEND);
		}
	}
	function OnSaleOrderPaidHandler(\Bitrix\Main\Event $event)
	{
		if (is_null($GLOBALS["SCODER_TOOLS"]))
		{
			
		}
	}
	function OnShipmentDeductedHandler(\Bitrix\Main\Event $event)
	{
		//Вызывается при сохранении, если был изменен флаг отгрузки.
		if (is_null($GLOBALS["SCODER_TOOLS"]))
		{
			$order   = $event->getParameter("ENTITY");
			
			//file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-log.txt', date("d.m.Y H:i:s -- ") . '$getId1: ' . var_export($order->getId(), true) . "\n", FILE_APPEND);
		}
	}
	function OnSaleShipmentReservedHandler(\Bitrix\Main\Event $event)
	{
		if (is_null($GLOBALS["SCODER_TOOLS"]))
		{
			$order   = $event->getParameter("ENTITY");
			
			//file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-log.txt', date("d.m.Y H:i:s -- ") . '$getId2: ' . var_export($order->getId(), true) . "\n", FILE_APPEND);
		}
	}
	//События после сохранения сущности https://dev.1c-bitrix.ru/api_d7/bitrix/sale/events/sale_entitysaved.php
	function OnSaleShipmentEntitySavedHandler(\Bitrix\Main\Event $event)
	{
		if (is_null($GLOBALS["SCODER_TOOLS"])
			&& Option::get("scoder.tools", "ACTIVE_SET_STATUS") == "Y"
		)
		{
			//объект сущности
			$entity = $event->getParameter("ENTITY");
			$oldValues = $event->getParameter("VALUES");
			
			$arEntityVals = $entity->getFields()->getValues();
			if (isset($oldValues['STATUS_ID']) && isset($arEntityVals['STATUS_ID']) && $oldValues['STATUS_ID'] != $arEntityVals['STATUS_ID'])
			{
				$ar = array(
					"id" => $arEntityVals['ORDER_ID'],			//Номер заказа в системе клиента 
					"code" => $arEntityVals['STATUS_ID'],		//Идентификатор статуса заказа в системе клиента
					//"message" => "",							//опционально, статус заказа в текстовом виде. Этот текст увидит покупатель в приложении
					//"trackingUrl" => "",						//опционально, ссылка на страницу отслеживания почтового или курьерского отправления
					//"userId" => ""							//опционально, идентификатор покупателя в вашей системе. В его качестве также может выступать номер телефона без форматирования. Используется для отправки пуш-уведомлений о заказах, сделанных не через приложение
				);
				
				$queryUrl = Option::get("scoder.tools", "ORDER_STATUS_URL");		//URL страницы для отправки изменений статусов по заказу
				
				$result = self::__curl_query($queryUrl, $ar);
				//file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-log.txt', date("d.m.Y H:i:s -- ") . '$ar: ' . var_export($ar, true) . "\n", FILE_APPEND);
				//file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-log.txt', date("d.m.Y H:i:s -- ") . '$result: ' . var_export($result, true) . "\n", FILE_APPEND);
			}
		}
	}
	function __curl_query($queryUrl, $fields)
	{
		$queryData = http_build_query($fields);
		
		$curl = curl_init();
		curl_setopt_array($curl, array(
			CURLOPT_SSL_VERIFYPEER => 0,
			CURLOPT_POST => 1,
			CURLOPT_HEADER => 0,
			CURLOPT_RETURNTRANSFER => 1,
			CURLOPT_URL => $queryUrl,
			CURLOPT_POSTFIELDS => $queryData,
		));
		$result = curl_exec($curl);
		curl_close($curl);
		$result = \Bitrix\Main\Web\Json::decode($result, 1);
		
		return $result;
	}
}
?>