<?
use Bitrix\Main;
use Bitrix\Main\Application;
use Bitrix\Main\Localization\Loc;
use Bitrix\Main\Config\Option;
use Bitrix\Sale;
use Bitrix\Sale\Location;
use Bitrix\Main\Context,
	Bitrix\Currency\CurrencyManager,
	Bitrix\Sale\Order,
	Bitrix\Sale\Basket,
	Bitrix\Sale\Delivery,
	Bitrix\Sale\PaySystem;

Loc::loadMessages(__FILE__); 

Class CScoderTools
{
	//imshop.io: оформление заказа [order]
	function Order($params = array())
    {
		global $USER;
		$result = array(
			"message" => "",
			"orders" => array(),
		);
		$jsonPost = json_decode(file_get_contents('php://input'), true);
		file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-order-log.txt', date("d.m.Y H:i:s -- ") . '$jsonPost: ' . var_export($jsonPost, true) . "\n", FILE_APPEND);		
		if (is_array($jsonPost['orders']))
		{
			
			$siteId =  self::__get_site();
			$GLOBALS["SCODER_TOOLS"]["order"] = "Y";
			$currencyCode = CurrencyManager::getBaseCurrency();
			$person_type = Option::get("scoder.tools", "PERSON_TYPE_ID");		//Тип плательщика по умолчанию для приложения imshop.io
			
			foreach ($jsonPost['orders'] as $data)
			{
				$items = array();
				$userId = $data["externalUserId"]>0 ? $data["externalUserId"] : 1;
				
				//ид службы доставки
				$deliveryID = 0;
				$exp = explode("/",$data["delivery"]);
				if (isset($exp[1]) && $exp[1] > 0)
					$deliveryID = (int)$exp[1];
				
				//ид платежной системы
				$paymentID = 0;
				$exp = explode("/",$data["payment"]);
				if (isset($exp[1]) && $exp[1] > 0)
					$paymentID = (int)$exp[1];
				//создаёт новый заказ
				$order = Order::create($siteId, $userId);
				//тип плательщика
				$order->setPersonTypeId($person_type);
				//валюта заказа
				$order->setField('CURRENCY', $currencyCode);
				
				//устанавливаем поля "комментарий к заказу", если задан
				if ($data["deliveryComment"]) {
					$order->setField('USER_DESCRIPTION', $data["deliveryComment"]);
				}
				if (is_array($data['items']))
				{
					// Создаём корзину с одним товаром
					$basket = Basket::create($siteId);
					foreach ($data['items'] as $data_basket)
					{
						$items[] = $data_basket;		//список товаров для ответа
						
						$productId = $data_basket["configurationId"];
						
						$item = $basket->createItem('catalog', $productId);
						$load = array(
							'QUANTITY' => $data_basket["quantity"],
							'PRICE' => $data_basket["price"]*$data_basket["quantity"],
							'CURRENCY' => $currencyCode,
							'LID' => $siteId,
							'PRODUCT_PROVIDER_CLASS' => '\CCatalogProductProvider',
						);
						$item->setFields($load);
					}
					$order->setBasket($basket);
				}
				// Устанавливаем свойства
				$propertyCollection = $order->getPropertyCollection();
				
				//телефон
				$phoneProp = $propertyCollection->getPhone();
				$phoneProp->setValue($data["phone"]);
				//имя покупателя
				$nameProp = $propertyCollection->getPayerName();
				$nameProp->setValue($data["name"]);
				
				//email
				$emailProp = $propertyCollection->getUserEmail();
				$emailProp->setValue($data["email"]);
				
				//address
				$addressProp = $propertyCollection->getAddress();
				$addressProp->setValue($data["address"]);
				
				$propertyLocation = $propertyCollection->getDeliveryLocation();
				$locationName = "";
			
				if ($data["addressData"]["settlement"] != "")
					$locationName = $data["addressData"]["settlement"];
				elseif ($data["addressData"]["city"] != "")
					$locationName = $data["addressData"]["city"];
				
				if ($locationName != "")
				{
					$oLocationTable = new \Bitrix\Sale\Location\LocationTable();
					$filter =  array (
						'=NAME.LANGUAGE_ID' => 'ru',
						'%=NAME.NAME' => $locationName,
						'TYPE.CODE' => array('COUNTRY','REGION','CITY','VILLAGE')
					);
					$res = $oLocationTable->getList(array(
						'select' => array('*', 'CITY_NAME' => 'NAME.NAME'),
						'filter' => $filter,
						'order' => array('NAME.NAME' => 'ASC'),
						'limit' => 1
					));
					if ($location = $res->fetch())
					{
						$propertyLocation->setField('VALUE',$location["CODE"]);
					}
				}
				
				// Создаём одну отгрузку и устанавливаем способ доставки
				$shipmentCollection = $order->getShipmentCollection();
				$shipment = $shipmentCollection->createItem(
					Bitrix\Sale\Delivery\Services\Manager::getObjectById($deliveryID)
				);
				
				$shipmentItemCollection = $shipment->getShipmentItemCollection();

				foreach ($order->getBasket() as $item)
				{
					$shipmentItem = $shipmentItemCollection->createItem($item);
					$shipmentItem->setQuantity($item->getQuantity());
				}
				
				// Создаём оплату со способом #1
				$paymentCollection = $order->getPaymentCollection();
				$payment = $paymentCollection->createItem(
					Bitrix\Sale\PaySystem\Manager::getObjectById($paymentID)
				);
				$payment->setField("SUM", $order->getPrice());
				$payment->setField("CURRENCY", $order->getCurrency());

				// Сохраняем
				$order->doFinalAction(true);
				$r = $order->save();
				$orderId = $order->getId();
				
				if($r->isSuccess())
				{
					$ar = array(
						"success" => true,				//флаг успеха. true если заказ принят
						"id" => $orderId,				//идентификатор созданного заказа в системе клиента
						"uuid" => $data["uuid"],		//идентификатор заказа в IMSHOP.IO, полученный в запросе
						"price" => $order->getPrice(),	//цена заказа
						"deliveryPrice" => $order->getDeliveryPrice(),		//цена доставки
						"items " => $items,				//список товаров в корзине
					);
					$result["orders"][] = $ar;
				}
				else
				{
					$message = implode("; ",$r->getErrorMessages());
					$ar = array(
						"success" => false,				//флаг успеха. true если заказ принят
						"errorCode" => 0,				//TODO код ошибки если success = false 
						"errorMessage" => $message,		//описание ошибки если success = false
						"uuid" => $data["uuid"],		//идентификатор заказа в IMSHOP.IO, полученный в запросе
						//"items " => $items,				//список товаров в корзине
					);
					$result["message"] = $message;
					$result["orders"][] = $ar;
				}
			}
		}
		return $result;
	}
	//imshop.io: синхронизация статусов заказов (входящий) [order.status]
	function OrderStatus($params = array())
    {
		global $USER;
		$result = array(
			"success" => false
		);
		$jsonPost = json_decode(file_get_contents('php://input'), true);
		file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-orderstatus-log.txt', date("d.m.Y H:i:s -- ") . '$jsonPost: ' . var_export($jsonPost, true) . "\n", FILE_APPEND);		
		if ($jsonPost["status"] != "" && $jsonPost["id"] >0)
		{
			$orderId = (int) $jsonPost["id"];
			$filter = array(
				"UF_IMSHOP_STATUS" => $jsonPost["status"],		//Идентификатор статуса заказа в IMSHOP.IO
			);
			//Ключи для сортировки
			$dbResult = CScoderApi::__get_list(array("ID" => "asc"), $filter, 1, array("*"), "scoder_tools_orderstatus");
			if ($fields = $dbResult->Fetch())
			{
				$btrue = false;
				$result = array(
					"success" => true,
					"status" => $fields['UF_STATUS_ID'],			//Код статуса (на сайте)
					"message" => $fields['UF_STATUS_MESSAGE'],		//Статус заказа в текстовом виде (увидит покупатель в приложении)
				);
				$order = Order::load($orderId);
				$GLOBALS["SCODER_TOOLS"]["order_status"] = "Y";
				if ($order->getId() > 0)
				{	
					//если меняется статус заказа
					if (strlen($fields['UF_STATUS_ID']) == 1)
					{
						$order->setField('STATUS_ID', $fields['UF_STATUS_ID']);		//Код статуса заказа
						$btrue = true;
					}
					elseif (strlen($fields['UF_STATUS_ID']) >= 2)		//если меняется статус доставки (отгрузка)
					{
						//--------ОТГРУЗКИ--------------
						$shipments = $order->getShipmentCollection();
						foreach ($shipments as $shipment)
						{
							if(!$shipment->isSystem())
							{
								$shipment->setField('STATUS_ID', $fields['UF_STATUS_ID']);
							}
						}
						$btrue = true;
					}
					if ($fields["UF_CANCELED"] == 1)
					{
						$order->setField('CANCELED', "Y");			//Флаг отмены заказа
						$btrue = true;
					}
					if ($fields["UF_PAYED"] == 1)
					{
						$order->setField('PAYED', "Y");				//Флаг оплаты заказа
						$btrue = true;
					}
					if ($fields["UF_DEDUCTED"] == 1)
					{
						$order->setField('DEDUCTED', "Y");			//Флаг отгрузки заказа
						$btrue = true;
					}
					if ($btrue)
					{
						$order->save();
					}
				}
			}
		}
		//file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-log.txt', date("d.m.Y H:i:s -- ") . '$params: ' . var_export($params, true) . "\n", FILE_APPEND);		
		return $result;
	}
	//imshop.io: доставки [deliveries]
	function Deliveries($params = array())
    {
		global $USER;
		$result = array(
			"success" => false
		);
		$jsonPost = json_decode(file_get_contents('php://input'), true);
		file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-deliveries1-log.txt', date("d.m.Y H:i:s -- ") . '$jsonPost: ' . var_export($jsonPost, true) . "\n", FILE_APPEND);		
		$siteId = self::__get_site();
		
		$userId = $jsonPost["externalUserId"]>0 ? $jsonPost["externalUserId"] : 1;		// идентификатор покупателя на стороне клиента, если тот авторизован в мобильном приложении, null по умолчанию
		
		// корзину товарами наполнять даже не обязательно
		$order = \Bitrix\Sale\Order::create($siteId, $userId);
		$person_type = Option::get("scoder.tools", "PERSON_TYPE_ID");		//Тип плательщика по умолчанию для приложения imshop.io
		$order->setPersonTypeId($person_type);
		
		if (is_array($jsonPost['items']))
		{
			// Создаём корзину с одним товаром
			$basket = Basket::create($siteId);
			$currencyCode = CurrencyManager::getBaseCurrency();
			
			foreach ($jsonPost['items'] as $data_basket)
			{
				$items[] = $data_basket;		//список товаров для ответа
				
				$productId = $data_basket["configurationId"];
				$item = $basket->createItem('catalog', $productId);
				
				$arPrice = CCatalogProduct::GetOptimalPrice($productId, $data_basket["quantity"], array(2),"N",array(),$siteId);
								
				$load = array(
					'QUANTITY' => $data_basket["quantity"],
					'PRICE' => $arPrice["DISCOUNT_PRICE"]*$data_basket["quantity"],
					'CURRENCY' => $currencyCode,
					'LID' => $siteId,
					'PRODUCT_PROVIDER_CLASS' => '\CCatalogProductProvider',
				);
				$item->setFields($load);
			}
			$order->setBasket($basket);
		}
		
		$shipmentCollection = $order->getShipmentCollection();
		$shipment = $shipmentCollection->createItem();
		$propertyCollection = $order->getPropertyCollection();
		$propertyLocation = $propertyCollection->getDeliveryLocation();
		
		if (is_array($jsonPost["addressData"]))
		{
			$locationName = "";
			
			if ($jsonPost["addressData"]["settlement"] != "")
				$locationName = $jsonPost["addressData"]["settlement"];
			elseif ($jsonPost["addressData"]["city"] != "")
				$locationName = $jsonPost["addressData"]["city"];
			
			if ($locationName != "")
			{
				$pickup_str = GetMessage("SCODER_TOOLS_IMSHOPIO_DELIVERY_PICKUP");	//фраза "самовывоз", будем проверять по присутствию этой фразы
				$oLocationTable = new \Bitrix\Sale\Location\LocationTable();
				$filter =  array (
					'=NAME.LANGUAGE_ID' => 'ru',
					'%=NAME.NAME' => $locationName,
					'TYPE.CODE' => array('COUNTRY','REGION','CITY','VILLAGE')
				);
				$res = $oLocationTable->getList(array(
					'select' => array('*', 'CITY_NAME' => 'NAME.NAME'),
					'filter' => $filter,
					'order' => array('NAME.NAME' => 'ASC'),
					'limit' => 1
				));
				if ($location = $res->fetch())
				{
					$propertyLocation->setField('VALUE',$location["CODE"]);
					
					$result = array();
					$deliveryList = \Bitrix\Sale\Delivery\Services\Manager::getRestrictedList($shipment, \Bitrix\Sale\Services\Base\RestrictionManager::MODE_CLIENT);
					foreach($deliveryList as $deliveryService)
					{
						$bpickup = false;
						if (substr_count(ToLower($deliveryService["NAME"]),$pickup_str) >=1)
							$bpickup = true;
						elseif (substr_count(ToLower($deliveryService["DESCRIPTION"]),$pickup_str) >=1)
							$bpickup = true;
						
						//TODO расчет стоимости доставки
						//$delivery_price = self::getDeliveryPriceForProduct($jsonPost, $siteId, $person_type, $deliveryService["ID"], 0, $location["CODE"]);
						//file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-deliveries1-log.txt', date("d.m.Y H:i:s -- ") . '$deliveryService: ' . var_export($deliveryService, true) . "\n", FILE_APPEND);		
						$result["deliveries"][] = array(
							"id" => $deliveryService["ID"],
							"title" => $deliveryService["NAME"],
							"hasPickupLocations" => false,		//способ доставки требует выбора пункта самовывоза (особенно важно при ответе на запросы со skipPickupLocations = true), обяз.
							"description" => $deliveryService["DESCRIPTION"],
							"type" => ($bpickup ? "pickup" : "delivery"),		//тип (delivery, pickup — доставка или самовывоз), обяз.
							"price" => (float) $delivery_price,				//TODO минимальная цена, цифра, обяз.
							"min" => 1,					//TODO минимальный срок доставки (0 - сегодня, 1 - завтра, 2-послезавтра, 3- от 3 дней), обяз.
						);
						//если этот параметр передан, и он равен true, то в ответе достаточно передать только способ самовывоза, и не передавать все доступные точки получения заказа
						if ($jsonPost["skipPickupLocations"] == true)
						{
							//locations — список ПВЗ (если type = pickup и требуется выбор пункта самовывоза, и в запросе не передан skipPickupLocations = true)
						}
					}
				}
			}
		}
		//file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-deliveries1-log.txt', date("d.m.Y H:i:s -- ") . '$result: ' . var_export($result, true) . "\n", FILE_APPEND);		
		return $result;
	}
	function getDeliveryPriceForProduct($jsonPost, $siteId, $personTypeId, $deliveryId, $paySystemId, $userCityId)
	{
		$result = null;
		$userId = $jsonPost["externalUserId"]>0 ? $jsonPost["externalUserId"] : 1;		// идентификатор покупателя на стороне клиента, если тот авторизован в мобильном приложении, null по умолчанию
		/** @var \Bitrix\Sale\Order $order */
		$order = \Bitrix\Sale\Order::create($siteId, $userId);
		$order->setPersonTypeId($personTypeId);
		
		if (is_array($jsonPost['items']))
		{
			// Создаём корзину с одним товаром
			$basket = Basket::create($siteId);
			$currencyCode = CurrencyManager::getBaseCurrency();
			
			foreach ($jsonPost['items'] as $data_basket)
			{
				$items[] = $data_basket;		//список товаров для ответа
				
				$productId = $data_basket["configurationId"];
				$item = $basket->createItem('catalog', $productId);
				
				$arPrice = CCatalogProduct::GetOptimalPrice($productId, $data_basket["quantity"], array(2),"N",array(),$siteId);
								
				$load = array(
					'QUANTITY' => $data_basket["quantity"],
					'PRICE' => $arPrice["DISCOUNT_PRICE"]*$data_basket["quantity"],
					'CURRENCY' => $currencyCode,
					'LID' => $siteId,
					'PRODUCT_PROVIDER_CLASS' => '\CCatalogProductProvider',
				);
				$item->setFields($load);
			}
			$order->setBasket($basket);
		}

		/** @var \Bitrix\Sale\PropertyValueCollection $orderProperties */
		$orderProperties = $order->getPropertyCollection();
		/** @var \Bitrix\Sale\PropertyValue $orderDeliveryLocation */
		$orderDeliveryLocation = $orderProperties->getDeliveryLocation();
		$orderDeliveryLocation->setValue($userCityId); // В какой город "доставляем" (куда доставлять).

		/** @var \Bitrix\Sale\ShipmentCollection $shipmentCollection */
		$shipmentCollection = $order->getShipmentCollection();

		$delivery = \Bitrix\Sale\Delivery\Services\Manager::getObjectById($deliveryId);
		/** @var \Bitrix\Sale\Shipment $shipment */
		$shipment = $shipmentCollection->createItem($delivery);

		/** @var \Bitrix\Sale\ShipmentItemCollection $shipmentItemCollection */
		$shipmentItemCollection = $shipment->getShipmentItemCollection();
		/** @var \Bitrix\Sale\BasketItem $basketItem */
		foreach ($basket as $basketItem) {
			$item = $shipmentItemCollection->createItem($basketItem);
			$item->setQuantity($basketItem->getQuantity());
		}
		if ($paySystemId > 0)
		{
			/** @var \Bitrix\Sale\PaymentCollection $paymentCollection */
			$paymentCollection = $order->getPaymentCollection();
			/** @var \Bitrix\Sale\Payment $payment */
			$payment = $paymentCollection->createItem(
				\Bitrix\Sale\PaySystem\Manager::getObjectById($paySystemId)
			);
			$payment->setField("SUM", $order->getPrice());
			$payment->setField("CURRENCY", $order->getCurrency());
		}
		// $result = $order->save(); // НЕ сохраняем заказ в битриксе - нам нужны только применённые "скидки" и "правила корзины" на заказ.
		// if (!$result->isSuccess()) {
		//     //$result->getErrors();
		// }

		$deliveryPrice = $order->getDeliveryPrice();
		if ($deliveryPrice === '') {
			$deliveryPrice = null;
		}
		$result = $deliveryPrice;

		return $result;
	}
	//imshop.io: оплаты [payments]
	function Payments($params = array())
    {
		global $USER;
		$result = array(
			"success" => false
		);
		$jsonPost = json_decode(file_get_contents('php://input'), true);
		file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-payments-log.txt', date("d.m.Y H:i:s -- ") . '$jsonPost: ' . var_export($jsonPost, true) . "\n", FILE_APPEND);		
		if (is_array($jsonPost["items"]))
		{
			$amount = 0;
			$siteId = self::__get_site();
			
			foreach ($jsonPost["items"] as $item)
			{
				$productId = $item["configurationId"];
				$arPrice = CCatalogProduct::GetOptimalPrice($productId, $item["quantity"], array(2),"N",array(),$siteId);
				
				if (isset($arPrice["DISCOUNT_PRICE"]))
				{
					$amount += $arPrice["DISCOUNT_PRICE"]*$item["quantity"];
				}
			}
			
			$order = \Bitrix\Sale\Order::create($siteId);
			$person_type = Option::get("scoder.tools", "PERSON_TYPE_ID");		//Тип плательщика по умолчанию для приложения imshop.io
			$order->setPersonTypeId($person_type);

			$paymentCollection = $order->getPaymentCollection();
			$extPayment = $paymentCollection->createItem();
			$extPayment->setField("SUM", $amount);
			$arPaySystemService = Sale\PaySystem\Manager::getListWithRestrictions($extPayment);
			$result = array();
			foreach ($arPaySystemService as $paySystem) {
				if ($paySystem["CODE"] != "")
				{					
					$result["payments"][] = array(
						"id" => $paySystem["ID"],
						"title" => $paySystem["NAME"],
						"description" => strip_tags($paySystem["DESCRIPTION"]),
						"type" => $paySystem["CODE"],
						//"deliveryDiscount" => 0		//процент скидки на выбранную доставку (если для оплаты доставка бесплатна, то 100), число 0-100
					);
				}
			}
		}
		return $result;
	}
	//imshop.io: проверка наличия товара [availability]
	function Availability($params = array())
    {
		global $USER;
		$result = array(
			"success" => false
		);
		$jsonPost = json_decode(file_get_contents('php://input'), true);
		file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-availability-log.txt', date("d.m.Y H:i:s -- ") . '$jsonPost: ' . var_export($jsonPost, true) . "\n", FILE_APPEND);		
		if (is_array($jsonPost["configurationIds"]) && count($jsonPost["configurationIds"]) > 0)
		{
			$warehouses = $availability = array();
			$default_store_id = 0;		//Склад по умолчанию
			//склады
			$dbResult = CCatalogStore::GetList(
			   array('ID' => 'ASC'),
			   array('ACTIVE' => 'Y'),
			   false,
			   false,
			   array("*")
			);
			while ($ar_res = $dbResult->Fetch())
			{
				if ($ar_res["IS_DEFAULT"] == "Y")
					$default_store_id = $ar_res["ID"];		//Склад по умолчанию
				
				$warehouses[] = array(
					"warehouseId" => $ar_res["ID"],
					"name" => $ar_res["TITLE"],
					"address" => $ar_res["ADDRESS"],
					"city" => $ar_res["DESCRIPTION"],		//город
					"lat" => $ar_res["GPS_N"],			//широта
					"lon" => $ar_res["GPS_S"],			//долгота
					"online" => true,					//является складом интернет магазина, доставляющим в заданный город (true / false)
					//"subway" => "",		//метро
					//"mall" => ""		//название ТЦ
				);
			}
			
			//наличие
			$filter = array(
				"ID" => $jsonPost["configurationIds"],
			);
			$db_res = CCatalogProduct::GetList(
				array("QUANTITY" => "DESC"),
				$filter,
				false,
				array("nTopCount" => 10),
				array("ID","QUANTITY")
			);
			while ($ar_res = $db_res->Fetch())
			{
				$items[$ar_res["ID"]] = $ar_res;
				//file_put_contents($_SERVER['DOCUMENT_ROOT'] . '/scoder-log.txt', date("d.m.Y H:i:s -- ") . '$ar_res: ' . var_export($ar_res, true) . "\n", FILE_APPEND);		
			}
			foreach ($jsonPost["configurationIds"] as $productId)
			{
				$availability[] = array(
					"id" => $productId, 
					"warehouseId" => $default_store_id, 
					"quantity" => (int) $items[$productId]["QUANTITY"]
				);
			}
			
			$result = array(
				"warehouses" => $warehouses,
				"availability" => $availability
			);
		}
		return $result;
	}
	function __get_site()
	{
		$siteId = Option::get("scoder.tools", "IMSHOP_IO_SITE_ID");		//Сайт для приложения imshop.io
		if ($siteId == "")
			$siteId = Context::getCurrent()->getSite();
		
		return $siteId;
	}
}
?>