<?
use Bitrix\Main\Localization\Loc; 
Loc::loadMessages(__FILE__); 

Class scoder_tools extends CModule
{
	const MODULE_ID = 'scoder.tools';
	var $MODULE_ID = 'scoder.tools'; 
	var $MODULE_VERSION;
	var $MODULE_VERSION_DATE;
	var $MODULE_NAME;
	var $MODULE_DESCRIPTION;
	var $MODULE_CSS;
	var $strError = '';

	function __construct()
	{
		$arModuleVersion = array();
		include(dirname(__FILE__)."/version.php");
		$this->MODULE_VERSION = $arModuleVersion["VERSION"];
		$this->MODULE_VERSION_DATE = $arModuleVersion["VERSION_DATE"];
		$this->MODULE_NAME = GetMessage("SCODER_TOOLS_MODULE_NAME");
		$this->MODULE_DESCRIPTION = GetMessage("SCODER_TOOLS_MODULE_DESC");

		$this->PARTNER_NAME = GetMessage("SCODER_TOOLS_PARTNER_NAME");
		$this->PARTNER_URI = GetMessage("SCODER_TOOLS_PARTNER_URI");
	}

	function InstallDB($arParams = array())
	{
		$eventManager = \Bitrix\Main\EventManager::getInstance(); 
		RegisterModule(self::MODULE_ID);
		//RegisterModuleDependences("main", "OnBeforeProlog", self::MODULE_ID, "CScoderToolsEvents", "OnBeforePrologHandler");
		RegisterModuleDependences("scoder.api", "OnBeforeConstructorAction", self::MODULE_ID, "CScoderToolsEvents", "OnBeforeConstructorActionHandler");
		RegisterModuleDependences("scoder.api", "OnBeforeConstructorResultShow", self::MODULE_ID, "CScoderToolsEvents", "OnBeforeConstructorResultShowHandler");
		
		$eventManager->registerEventHandler("sale","OnSaleOrderBeforeSaved",self::MODULE_ID,"CScoderToolsEvents","OnSaleOrderBeforeSavedHandler");
		$eventManager->registerEventHandler("sale","OnSaleOrderSaved",self::MODULE_ID,"CScoderToolsEvents","OnSaleOrderSavedHandler");
		$eventManager->registerEventHandler("sale","OnSaleOrderCanceled",self::MODULE_ID,"CScoderToolsEvents","OnSaleOrderCanceledHandler");
		$eventManager->registerEventHandler("sale","OnSaleStatusOrderChange",self::MODULE_ID,"CScoderToolsEvents","OnSaleStatusOrderChangeHandler");
		$eventManager->registerEventHandler("sale","OnSaleOrderPaid",self::MODULE_ID,"CScoderToolsEvents","OnSaleOrderPaidHandler");
		$eventManager->registerEventHandler("sale","OnShipmentDeducted",self::MODULE_ID,"CScoderToolsEvents","OnShipmentDeductedHandler");
		$eventManager->registerEventHandler("sale","OnSaleShipmentReserved",self::MODULE_ID,"CScoderToolsEvents","OnSaleShipmentReservedHandler");
		
		$eventManager->registerEventHandler("sale","OnSaleShipmentEntitySaved",self::MODULE_ID,"CScoderToolsEvents","OnSaleShipmentEntitySavedHandler");
		return true;
	}

	function UnInstallDB($arParams = array())
	{
		$eventManager = \Bitrix\Main\EventManager::getInstance(); 
		//UnRegisterModuleDependences("main", "OnBeforeProlog", self::MODULE_ID, "CScoderToolsEvents", "OnBeforePrologHandler");
		UnRegisterModuleDependences("scoder.api", "OnBeforeConstructorAction", self::MODULE_ID, "CScoderToolsEvents", "OnBeforeConstructorActionHandler");
		UnRegisterModuleDependences("scoder.api", "OnBeforeConstructorResultShow", self::MODULE_ID, "CScoderToolsEvents", "OnBeforeConstructorResultShowHandler");
		
		$eventManager->unRegisterEventHandler("sale","OnSaleOrderBeforeSaved",self::MODULE_ID,"CScoderToolsEvents","OnSaleOrderBeforeSavedHandler");
		$eventManager->unRegisterEventHandler("sale","OnSaleOrderSaved",self::MODULE_ID,"CScoderToolsEvents","OnSaleOrderSavedHandler");
		$eventManager->unRegisterEventHandler("sale","OnSaleOrderCanceled",self::MODULE_ID,"CScoderToolsEvents","OnSaleOrderCanceledHandler");
		$eventManager->unRegisterEventHandler("sale","OnSaleStatusOrderChange",self::MODULE_ID,"CScoderToolsEvents","OnSaleStatusOrderChangeHandler");
		$eventManager->unRegisterEventHandler("sale","OnSaleOrderPaid",self::MODULE_ID,"CScoderToolsEvents","OnSaleOrderPaidHandler");
		$eventManager->unRegisterEventHandler("sale","OnShipmentDeducted",self::MODULE_ID,"CScoderToolsEvents","OnShipmentDeductedHandler");
		$eventManager->unRegisterEventHandler("sale","OnSaleShipmentReserved",self::MODULE_ID,"CScoderToolsEvents","OnSaleShipmentReservedHandler");
		
		$eventManager->unRegisterEventHandler("sale","OnSaleShipmentEntitySaved",self::MODULE_ID,"CScoderToolsEvents","OnSaleShipmentEntitySavedHandler");
		
		UnRegisterModule(self::MODULE_ID);
		return true;
	}
	
	function InstallEvents($arParams = array())
	{
		return true;
	}

	function UnInstallEvents($arParams = array())
	{
		return true;
	}

	function InstallFiles($arParams = array())
	{		
		return true;
	}

	function UnInstallFiles()
	{	
		
		return true;
	}

	function DoInstall()
	{
		global $APPLICATION;
		$this->InstallFiles();
		$this->InstallEvents();
		$this->InstallDB();
		$APPLICATION->IncludeAdminFile(GetMessage("SCODER_TOOLS_INST_TITLE"), $_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/".self::MODULE_ID."/install/step.php");
	}

	function DoUninstall()
	{
		global $APPLICATION;

		$APPLICATION->ResetException();
		if (!check_bitrix_sessid())
			return false;
		
		$step = IntVal($_REQUEST['step']);
		if($step < 2)
		{
			$APPLICATION->IncludeAdminFile(GetMessage("SCODER_TOOLS_UNINST_TITLE"), $_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/".self::MODULE_ID."/install/unstep1.php");
		}
		elseif($step == 2)
		{
			$this->UnInstallDB();
			$this->UnInstallFiles();
			$this->UnInstallEvents();
			$APPLICATION->IncludeAdminFile(GetMessage("SCODER_TOOLS_UNINST_TITLE"), $_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/".self::MODULE_ID."/install/unstep2.php");
		}	
	}
}
?>